/*
 * fancysockbroadcastable.h
 *
 *  Created on: 26.07.2009
 *      Author: wglas
 */

#ifndef FANCYSOCKBROADCASTABLE_H_
#define FANCYSOCKBROADCASTABLE_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class String;
class Map;

namespace Sock {

/**
 * An interface for contexts, which accept broadcast calls.
 * This interface is the abstraction a server sees from a single client connection.
 */
class FANCYSOCK_API Broadcastable: public virtual Fancy::Object {
protected:
	Broadcastable();
	virtual ~Broadcastable();
public:
	typedef Fancy::ObjPtr<Broadcastable> ptr_t;

    /**
     * @param subSystem The subsystem name to which a oneway invocation will be broadcasted.
     * @param arg The argument to the broadcast.
     * @param metadata Metadata to pass to the call.
     */
	virtual void broadcast(const Fancy::ObjPtr<String> &subSystem,
			               const Fancy::ObjPtr<Fancy::Object> &arg,
			               const Fancy::ObjPtr<Fancy::Map> &metadata) = 0;

};
}
}

#endif /* FANCYSOCKBROADCASTABLE_H_ */
