/*
 * fancysockconnectionhandler.h
 *
 *  Created on: 19.07.2009
 *      Author: wglas
 */

#ifndef FANCYSOCKCONNECTIONHANDLER_H_
#define FANCYSOCKCONNECTIONHANDLER_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class Runnable;

namespace Sock {

class Device;

/**
 * A factory interface for connection handlers.
 */
class FANCYSOCK_API ConnectionHandlerFactory: public virtual Fancy::Object {
protected:
	ConnectionHandlerFactory() {}
	virtual ~ConnectionHandlerFactory();

public:
	typedef Fancy::ObjPtr<ConnectionHandlerFactory> ptr_t;

	/**
	 * Instantiate a new connection handler for the given device.
	 *
	 * @param device The device to mange in side the returned runnable.
	 * @return A new connection handler instance suitable for the given device.
	 */
	virtual Fancy::ObjPtr<Fancy::Runnable> newConnectionHandler(const Fancy::ObjPtr<Device> &device) = 0;
};

}
}

#endif /* FANCYSOCKCONNECTIONHANDLER_H_ */
