// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysockexception.h 89 2007-12-18 20:28:22Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global exception class stuff.
** 
*****************************************************************************/

#ifndef FANCYSOCK_EXCEPTION_H
#define FANCYSOCK_EXCEPTION_H

#include <fancyexception.h>
#include <fancysock.h>

namespace Fancy {
  namespace Sock {
    class FANCYSOCK_API Exception : public Fancy::Exception
    { 
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      ~Exception() throw ();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority) throw();
    };

    class FANCYSOCK_API CException : public Fancy::CException
    { 
    public:
      CException (int facility,
                  int priority,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      CException (int facility,
                  int priority,
                  int _err,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,5,6)))
#endif
        ;

      ~CException() throw();
    };

  }
}

#endif // ! FANCYSOCK_LOG_H
