/*
 * fancysockinvocationauthenticator.h
 *
 *  Created on: 09.08.2009
 *      Author: wglas
 */

#ifndef FANCYSOCKINVOCATIONAUTHENTICATOR_H_
#define FANCYSOCKINVOCATIONAUTHENTICATOR_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class Map;
template <class T> class ObjectArray;
class String;
class ReflectionTarget;

namespace Sock {

class InvocationContext;

class FANCYSOCK_API InvocationAuthenticator: public virtual Fancy::Object {
protected:
    InvocationAuthenticator();
    virtual ~InvocationAuthenticator();
public:
    typedef Fancy::ObjPtr<InvocationAuthenticator> ptr_t;

    virtual void authenticate(const Fancy::ObjPtr<InvocationContext> &ctx,
                              const Fancy::ObjPtr<Fancy::ReflectionTarget> &target,
                              const Fancy::ObjPtr<Fancy::String> &method,
                              const Fancy::ObjPtr<Fancy::ObjectArray<Fancy::Object> > &args,
                              const Fancy::ObjPtr<Fancy::Map> &metadata   ) = 0;
};

}

}

#endif /* FANCYSOCKINVOCATIONAUTHENTICATOR_H_ */
