/*
 * fancysockinvocationcontext.h
 *
 *  Created on: 26.07.2009
 *      Author: wglas
 */

#ifndef FANCYSOCKINVOCATIONCONTEXT_H_
#define FANCYSOCKINVOCATIONCONTEXT_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class UID;

namespace Sock {

/**
 * The context under which a call is invoked. If the context implements
 * {@link CallbackInvocationContext}, the {@link InvocationHandler} may
 * issue a callback to the originating invoker.
 */
class FANCYSOCK_API InvocationContext: public virtual Fancy::Object {
protected:
	InvocationContext();
	virtual ~InvocationContext();
public:
	typedef Fancy::ObjPtr<InvocationContext> ptr_t;

	/**
	 * @return The client UID to which this context belongs.
	 */
	virtual Fancy::ObjPtr<Fancy::UID> getClientUID() const = 0;
};

}

}

#endif /* FANCYSOCKINVOCATIONCONTEXT_H_ */
