/*
 * fancysockremotingconnectionhandler.h
 *
 *  Created on: 06.08.2009
 *      Author: wglas
 */

#ifndef FANCYSOCKREMOTINGCONNECTIONHANDLER_H_
#define FANCYSOCKREMOTINGCONNECTIONHANDLER_H_

#include <fancythread.h>
#include <fancysockbroadcastable.h>
#include <fancysockconnectionhandler.h>

namespace Fancy {

class SerializableFactory;
class String;

namespace Sock {

class Broadcastable;
class InvocationHandler;

class FANCYSOCK_API RemotingConnectionHandlerFactory:
                        public virtual ConnectionHandlerFactory,
                        public virtual Broadcastable {

protected:
	RemotingConnectionHandlerFactory();
	~RemotingConnectionHandlerFactory();
public:
	typedef Fancy::ObjPtr<RemotingConnectionHandlerFactory> ptr_t;

	static ptr_t newInstance(const Fancy::ObjPtr<Fancy::SerializableFactory> &serializableFactory);

	virtual void registerInvocationHandler(const Fancy::ObjPtr<Fancy::String> &subSystem, const Fancy::ObjPtr<InvocationHandler> &handler) = 0;

	virtual void deregisterInvocationHandler(const Fancy::ObjPtr<Fancy::String> &subSystem) = 0;

	virtual Fancy::ObjPtr<InvocationHandler> getInvocationHandler(const Fancy::ObjPtr<Fancy::String> &subSystem) const = 0;

	virtual int getBufferSize() const = 0;
	virtual void setBufferSize(int n) = 0;
};

}

}

#endif /* FANCYSOCKREMOTINGCONNECTIONHANDLER_H_ */
