/*
 * fancysockstateful.h
 *
 *  Created on: 05.01.2010
 *      Author: wglas
 */

#ifndef FANCYSOCKSTATEFUL_H_
#define FANCYSOCKSTATEFUL_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

namespace Sock {

/**
 * this interface is implemented by classes, which have an internal state, which
 * may be reported to the outside in a thread-safe manner.
 */
class FANCYSOCK_API Stateful: public virtual Fancy::Object {

public:
	typedef Fancy::ObjPtr<Stateful> ptr_t;

    /**
      This virtual function returns a user-readable status report for daemons,
      servers and other stateful facilities.

      This function should be implemented in a thread-safe manner.

      @param os The output stream to write to.
    */
	virtual void printStatus(std::ostream &os) const = 0;

protected:
	Stateful();
	virtual ~Stateful();
};

}

}

#endif /* FANCYSOCKSTATEFUL_H_ */
