// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysocktransstream.h 685 2010-07-26 08:22:39Z fancylibs $
**
** Copyright (C) 2005 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** stream classes, which encapsulate writing/reading a document from/to a
** transport.
** 
*****************************************************************************/

#ifndef FANCYSOCK_TRANS_STREAM_H
#define FANCYSOCK_TRANS_STREAM_H

#include <iostream>
#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {
  class Map;

  namespace Sock {

    class Transport;

    class FANCYSOCK_API itransstreambuf : public std::streambuf
    {
    public:
      itransstreambuf(const Fancy::ObjPtr<Transport> &t, Fancy::ObjPtr<Map> &headers, int timeout);
      virtual ~itransstreambuf();

    protected:
      int_type underflow (int c);

    private:
      int fill_buffer();

      Fancy::ObjPtr<Transport> transport;
    };

    class FANCYSOCK_API itransstream : public std::istream
    {
      itransstreambuf itsbuf;
    public:
      itransstream(const Fancy::ObjPtr<Transport> &t, Fancy::ObjPtr<Map> &headers, int timeout);
      virtual ~itransstream();
    };

    class FANCYSOCK_API otransstreambuf : public std::streambuf
    {
    public:
      otransstreambuf(const Fancy::ObjPtr<Transport> &t, const Fancy::ObjPtr<Map> &headers);
      virtual ~otransstreambuf();

    protected:
      int_type overflow (int_type c);
      int sync();

    private:
      int put_buffer();

      Fancy::ObjPtr<Transport> transport;
    };

    class FANCYSOCK_API otransstream : public std::ostream
    {
      otransstreambuf otsbuf;
    public:
      otransstream(const Fancy::ObjPtr<Transport> &t, const Fancy::ObjPtr<Map> &headers);
      ~otransstream();
    };

  }
}

#endif
